VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   Begin VB.CommandButton cmdSetSize 
      Caption         =   "Set Size"
      Height          =   375
      Left            =   720
      TabIndex        =   1
      Top             =   840
      Width           =   975
   End
   Begin VB.ComboBox cboDisplaySize 
      Height          =   315
      ItemData        =   "Form1.frx":0000
      Left            =   240
      List            =   "Form1.frx":0002
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   240
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const CCHDEVICENAME = 32
Private Const CCHFORMNAME = 32
Private Type DEVMODE
    dmDeviceName As String * CCHDEVICENAME
    dmSpecVersion As Integer
    dmDriverVersion As Integer
    dmSize As Integer
    dmDriverExtra As Integer
    dmFields As Long
    dmOrientation As Integer
    dmPaperSize As Integer
    dmPaperLength As Integer
    dmPaperWidth As Integer
    dmScale As Integer
    dmCopies As Integer
    dmDefaultSource As Integer
    dmPrintQuality As Integer
    dmColor As Integer
    dmDuplex As Integer
    dmYResolution As Integer
    dmTTOption As Integer
    dmCollate As Integer
    dmFormName As String * CCHFORMNAME
    dmUnusedPadding As Integer
    dmBitsPerPel As Integer
    dmPelsWidth As Long
    dmPelsHeight As Long
    dmDisplayFlags As Long
    dmDisplayFrequency As Long
End Type
Private Declare Function EnumDisplaySettings Lib "user32.dll" Alias "EnumDisplaySettingsA" (ByVal lpszDeviceName As Long, ByVal iModeNum As Long, ByRef lpDevMode As DEVMODE) As Long

Private Declare Function ChangeDisplaySettings Lib "user32.dll" Alias "ChangeDisplaySettingsA" (ByRef lpDevMode As DEVMODE, ByVal dwFlags As Long) As Long
Private Const DM_BITSPERPEL = &H40000
Private Const DM_DISPLAYFLAGS = &H200000
Private Const DM_DISPLAYFREQUENCY = &H400000
Private Const DM_PELSHEIGHT = &H100000
Private Const DM_PELSWIDTH = &H80000
Private Const DM_POSITION = &H20&

Private Const CDS_UPDATEREGISTRY = &H1
Private Const CDS_TEST = &H2
Private Const CDS_FULLSCREEN = &H4
Private Const CDS_GLOBAL = &H8
Private Const CDS_SET_PRIMARY = &H10
Private Const CDS_NORESET = &H10000000
Private Const CDS_SETRECT = &H20000000
Private Const CDS_RESET = &H40000000
Private Const CDS_FORCE = &H80000000

Private Const DISP_CHANGE_BADFLAGS = -4
Private Const DISP_CHANGE_BADMODE = -2
Private Const DISP_CHANGE_BADPARAM = -5
Private Const DISP_CHANGE_FAILED = -1
Private Const DISP_CHANGE_NOTUPDATED = -3
Private Const DISP_CHANGE_RESTART = 1
Private Const DISP_CHANGE_SUCCESSFUL = 0

Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Const HORZRES = 8       ' Screen width in pixels
Private Const VERTRES = 10      ' Screen height in pixels
Private Const BITSPIXEL = 12    ' Bits of color per pixel
' Set the indicated display size and color depth.
Private Function SetDisplayMode(ByVal wid As Long, ByVal hgt As Long, ByVal bpp As Long, ByVal change_flags As Long) As Long
Dim dev_mode As DEVMODE
Dim result As Long

    ' Set the desired mode.
    With dev_mode
        .dmSize = Len(dev_mode)
        .dmDriverExtra = 0
        .dmFields = DM_PELSWIDTH Or DM_PELSHEIGHT Or DM_BITSPERPEL
        .dmPelsWidth = wid
        .dmPelsHeight = hgt
        .dmBitsPerPel = bpp
    End With

    ' Make the change.
    result = ChangeDisplaySettings(dev_mode, change_flags)
    Select Case result
        Case DISP_CHANGE_BADFLAGS
            MsgBox "Invalid flags in ChangeDisplaySettings"
        Case DISP_CHANGE_BADMODE
            MsgBox "Graphics mode not supported"
        Case DISP_CHANGE_BADPARAM
            MsgBox "Invalid parameter to ChangeDisplaySettings"
        Case DISP_CHANGE_FAILED
            MsgBox "Display driver failed in specific graphics mode in ChangeDisplaySettings"
        Case DISP_CHANGE_NOTUPDATED
            MsgBox "Unable to write changes to Registry in ChangeDisplaySettings"
        Case DISP_CHANGE_RESTART
            MsgBox "Restart required before changes can take effect"
        Case DISP_CHANGE_SUCCESSFUL
            ' It worked.
    End Select

    SetDisplayMode = result
End Function

Private Sub cmdSetSize_Click()
Dim txt As String
Dim wid As Integer
Dim hgt As Integer
Dim bpp As Integer
Dim dev_mode As DEVMODE
Dim result As Long

    ' Get the desired values.
    txt = cboDisplaySize.Text
    wid = CLng(Split(txt, "x")(0))
    txt = Split(txt, "x")(1)
    hgt = CLng(Split(txt, "(")(0))
    txt = Split(txt, "(")(1)
    bpp = CLng(Split(txt, " ")(0))

    ' Test the desired mode.
    If SetDisplayMode(wid, hgt, bpp, CDS_TEST) = DISP_CHANGE_SUCCESSFUL Then
        ' The test worked. Make the change.
        SetDisplayMode wid, hgt, bpp, CDS_UPDATEREGISTRY
    End If
End Sub
Private Sub Form_Load()
Dim dev_mode As DEVMODE
Dim mode_num As Long

    ' List the display modes.
    dev_mode.dmSize = Len(dev_mode)
    dev_mode.dmDriverExtra = 0
    mode_num = 0
    Do While EnumDisplaySettings(0, mode_num, dev_mode) <> 0
        cboDisplaySize.AddItem _
            Format$(dev_mode.dmPelsWidth) & " x " & _
            Format$(dev_mode.dmPelsHeight) & " (" & _
            Format$(dev_mode.dmBitsPerPel) & " bit)"
        mode_num = mode_num + 1
    Loop

    ' Select the current value.
    cboDisplaySize.Text = _
        Format$(GetDeviceCaps(hdc, HORZRES)) & " x " & _
        Format$(GetDeviceCaps(hdc, VERTRES)) & " (" & _
        Format$(GetDeviceCaps(hdc, BITSPIXEL)) & " bit)"
End Sub


